; LCD display functions
; Display is connected to PORTC

; send W to LCD, via serial shift register
; SReg has mode data, bits 2,3,4
SendLCD	
        clrwdt
	movwf	TEST		; save char to display
	bcf	PORTC, C_SMR	; reset shift reg
        nop
	bsf	PORTC, C_SMR	; Enable shift reg
	bcf	PORTC, C_DRS	; set reg select, ins
        btfsc	SReg,  C_DRS	; skip next if instruction
	bsf	PORTC, C_DRS	; clear reg select
; Clock data into shift register
        movlw	08h		; number of bits to clock
        movwf	Count
Clkdat	clrwdt
	bcf	PORTC, C_SCL	; set clock to 0
	bcf	PORTC, C_DS2	; set data bit to 0
        btfsc	TEST, 7		; check bit 7
	bsf	PORTC, C_DS2	; set data bit to 1
        nop
	bsf	PORTC, C_SCL	; set clock to 1
        rlf	TEST, 1		; rotate bits
        decfsz	Count, 1
        goto	Clkdat
        bcf	PORTC, C_DRW	; Set to Write mode
        nop
        bsf	PORTC, C_DEN	; 
        nop
;        call	delay1
        bcf	PORTC, C_DEN	; 
        nop
        bsf	PORTC, C_DRW	; Set to Read mode
	bcf	PORTC, C_DRS	; set reg select

BCFD    
	nop
;	call	delay1
	bsf	PORTC, C_DEN	; clock data
	nop
;	call	delay1
        btfss	PORTC, C_DBF	; read Busy Flag
	bsf	Temp1, 0		; set not-busy flag
        bcf	PORTC, C_DEN	; 
        btfss	Temp1, 0		; read Not-Busy Flag
	goto	BCFD		; Not-Busy, exit
	retlw	0

; Display a string of chars to the LCD display with FSR pinteing to the start of the string
; If a zero byte is encounterd, or 16 chars stop
StrLCD
	movlw	.16	; max 16 chars
	movwf	Mode	; set char counter
	bcf	SReg, C_DRS	; set command mode
 	movlw	080h	; Set DDRAM address to left side RAM
SetRAM  call 	SendLCD
STNX    clrwdt
	bsf	SReg, C_DRS	; set data mode
	movfw	0	; get byte
	bz	StrEND	; test if it is zero
        call	SendLCD	; display char
        incf	FSR,1	; point to next char
        decfsz	Mode,1
        goto	SLCD1
StrEND  retlw 0
SLCD1   movfw	Mode
        xorlw	.8	; see if we have done 8 chars
        bnz	STNX	; do next char
	bcf	SReg, C_DRS	; set command mode
       	movlw	0C0h	; Set DDRAM address to right side RAM
        goto	SetRAM

