        TITLE   "OPTREX 16117A LCd display TEST
        LIST    P=16C57

        include "p16c5x.inc" ; MPASM include file

	__CONFIG _XT_OSC & _CP_OFF & _WDT_ON

	ERRORLEVEL	0, -306

;**********************************************************
; PORT A - NC
; PORT B - Serial and Programming I/O
; PORT C - Buttons and Display
;**********************************************************
; Timing for 4Mhz
;**********************************************************

        include "picreg.h"
        include "pagemacs.h"
        include "lcd.h"

        org     0000h
        goto	INIT

SetB0Base
        movlw   B0Base+0x10	; Set RAM Bank 0
        movwf   FSR
	retlw	0
SetB1Base
        movlw   B1Base+0x10	; Set RAM Bank 1
        movwf   FSR
	retlw	0
SetB2Base
        movlw   B2Base+0x10	; Set RAM Bank 2
        movwf   FSR
	retlw	0
SetB3Base
        movlw   B3Base+0x10	; Set RAM Bank 3
        movwf   FSR
	retlw	0

INIT
        movlw   00h             ; all outputs
        tris    PORTA
        movlw   00h		; All outputs
        tris    PORTB          ; Ports initialized
        movlw   80h		; bit 7 input, all others outputs
        tris    PORTC          ; Ports initialized

	call	delay20	
;	Page01			; Switch to page 1
InitD	clrf	SReg	; Instruction
	movlw	38h	; Set Function, 2 line, 8-bit
        call 	SendLCD
	movlw	0ch	; enable display, cursor off, blink off
        call 	SendLCD
	movlw	06h	; Entry mode, move cursor, shift
        call 	SendLCD
	movlw	01h	; clear display and home cursor
        call 	SendLCD
	movlw	080h	; Set DDRAM address
        call 	SendLCD
        movlw	30h
        movwf	Mode
        bsf	SReg, C_DRS	;  select Data input
IDT1	
        clrwdt
	call	SendLCD
        incf	Mode, 1
        movfw	Mode
        xorlw	38h
        bz	INIT2
        movlw	.200
        call	delayx
        movfw	Mode
        goto	IDT1

INIT2
	call	SetB1Base	; set RAM bank 1
        movlw	0x10
        call	SRAMWrite
	call	SetB2Base	; set RAM bank 2
        movlw	0x10
        call	SRAMRead
	call	SetB2Base	; set RAM bank 1
        call	StrLCD		; display Data
	movlw	01h		; Start with all voltages off
        movwf	PORTA
        call	SetB0Base
	clrf	Mode

LP1	clrwdt
	btfss	PORTB, 0	; test for button
	goto	LP1		; loop forever

; Button is pressed, wait for release
BTN1	call	delay20		; Delay 20 ms
	btfsc	PORTB, 0	; test for button
	goto	BTN1		; loop forever
        goto	LP1

delay20
        movlw   .20             ; delay 20 ms
        goto	delayx

delay1				; Delay 1 ms
        movlw   1
delayx				; delay x ms, 4 Mhz == 1 Instruction/yS, x * 1000 
        movwf   Temp
dxlp
        movlw   .248
        movwf   DCnt
dl11
        clrwdt            ; 1.25 msec ! (Change !)
        decfsz  DCnt,1
        goto    dl11      ; 4 x 248 = 992 + 8 = 1000
        decfsz  Temp,1
        goto    dxlp
        retlw   0

        include "display.asm"

        END

